proc trees_register_and_mosaic {} {
    global session capture registration mosaic labels noprompting
    global gaugevar

    if {$registration(status) != "COMPLETE"  ||  $mosaic(status) != "COMPLETE"} {
        set gaugenum [gauge_gui_add "Register & Mosaic Frames"]
        
        if {$gaugenum != 0} {gauge_gui_update $gaugenum 10}
        if {$gaugevar(cancel) != 0} {
            if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
            return;
        }
        
        trees_register_frames
        if {$gaugenum != 0} {gauge_gui_update $gaugenum 50}
        if {$gaugevar(cancel) != 0} {
            if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
            return;
        }
        
        trees_create_mosaic
        if {$gaugenum != 0} {gauge_gui_update $gaugenum 100}

        if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
    }



    if {$mosaic(status) == "COMPLETE"} {
        if {$noprompting != 1} {
            set answer [tk_dialog .dlg "Continuing Analysis Dialog" \
                     "The next step is tree ring identification.  Do you wish to continue?" \
                     question \
                     1 $labels(button,no) $labels(button,yes) ]
        } else {
            set answer 1
        }
        
        if {$answer == 1} {
            trees_find_rings
        }
    }
}


proc trees_register_frames {} {
    global session capture registration mosaic labels noprompting
    global gaugevar
    
    set gaugenum 0

    if {$capture(status) != "COMPLETE"} {
        messagebox "Registration Error" "Cannot register frames because they have not been captured yet."
        set registration(status) NONE
    } elseif {$capture(framecount) < 1} {
        messagebox "Registration Error" "Cannot register frames because one or more frames are not present."
        set registration(status) NONE
    } elseif {$registration(status) != "COMPLETE"} {

        set mosaic(status) ACTIVE
        set registration(status) ACTIVE
        trees_update_status


        set dir "$session(directory)/images/frames"
        
        # Determine if frames should be adjusted for illumination
        #   nonuniformity
        if {$capture(illumination) != "NONE"} {
            if {$noprompting != 1} {
                set registration(illum-adjust) [tk_dialog .dlg $labels(register,illum-title) \
                         $labels(register,illum-message) \
                         question \
                         1 $labels(button,no) $labels(button,yes) ]
            } else {
                set registration(illum-adjust) 1
            }
                     
            if {$registration(illum-adjust)} {
                set img(illum) [Sadie_FileIO_Open ${dir}/$capture(illumination) 0 illum]

                #set temp1 [Sadie_FileIO_Open ${dir}/$capture(illumination) 0 illum]

		# Suppress range from 0.0 to 1.0
		#global StretchVar
		#set StretchVar(inimg,addr) $temp1
		#set StretchVar(minorbias) 0.0
		#set StretchVar(maxorgain) 1.0
		#set StretchVar(type) 0
		#set StretchVar(outname) "SuppRange"
		#set temp2 [Sadie_Contrast_LinearStretch StretchVar]
		#unset StretchVar
		#Sadie_General_Close $temp1
		#unset temp1
		
		# Shift mean to 1.0
		#global SetMeanVar
		#set SetMeanVar(inimg,addr) $temp2
		#set SetMeanVar(mean) 1.0
		#set SetMeanVar(outname) Illumination
		#set img(illum) [Sadie_Proto_SetMean SetMeanVar]
		#unset SetMeanVar
		#Sadie_General_Close $temp2
		#unset temp2
            }
        } else {
            set registration(illum-adjust) 0
        }
        if {$noprompting != 1} {
	    set registration(biasgain-adjust) [tk_dialog .dlg $labels(register,biasgain-title) \
		     $labels(register,biasgain-message) \
		     question \
		     1 $labels(button,no) $labels(button,yes) ]
        } else {
	    set registration(biasgain-adjust) 1
        }

	if {$registration(illum-adjust)} {
	    global CombineVar
	    set CombineVar(option) 3
	    set CombineVar(weight1) 1.0
	    set CombineVar(weight2) 1.0
	    set CombineVar(inimg,addr2) $img(illum)
	}	
        set gaugenum [gauge_gui_add "Register Frames"]

        set img(0) [Sadie_FileIO_Open ${dir}/$capture(frame0,file) 0 img0]
        puts "img(0) = $img(0)"
        # This seems to be necessary to give tcl enough time to
        #   properly store the address variable
        after 5
        if {$registration(illum-adjust)} {
	    set CombineVar(inimg,addr1) $img(0)
	    set CombineVar(outname) "combine0"
            set img(0) [Sadie_Multi_Combine CombineVar]
	    puts "tempimg = $CombineVar(inimg,addr1), img(0) = $img(0)"
	    Sadie_General_Close $CombineVar(inimg,addr1)
        }
        puts "getting range..."
        set results [Sadie_TREES_GetRange $img(0)]
        set registration(frame0,gmin) [lindex $results 0]
        set registration(frame0,gmax) [lindex $results 1]
        set registration(frame0,x) 0
        set registration(frame0,y) 0
        set registration(frame0,gain) 1.0
        set registration(frame0,bias) 0.0


	global FindRegisterVar
	

	if {$capture(framecount) == 1} {
	    if {$gaugevar(cancel) != 0} {
		set registration(status) NONE
	    } else {
		set registration(status) COMPLETE
	    }
	} else {
	    for {set i 1} {$i < $capture(framecount)} {incr i} {
		gauge_gui_update $gaugenum [expr round(($i*100)/$capture(framecount))]
		if {$gaugevar(cancel) != 0} {
		    break;
		}

		set img($i) [Sadie_FileIO_Open ${dir}/$capture(frame${i},file) 0 img$i]
		puts "img($i) = $img($i)"
		# This seems to be necessary to give tcl enough time to
		#   properly store the address variable
		after 5
		if {$registration(illum-adjust)} {
		    set CombineVar(inimg,addr1) $img($i)
		    set CombineVar(outname) "combine$i"
		    set img($i) [Sadie_Multi_Combine CombineVar]
		    puts "tempimg = $CombineVar(inimg,addr1), img($i) = $img($i)"
		    Sadie_General_Close $CombineVar(inimg,addr1)
		}

		puts "Finding registration for image $i"
		puts "Sadie_Proto_FindRegister img([expr $i - 1]) img($i) $capture(frame${i},estx) $capture(frame${i},esty)"
		puts "img([expr $i - 1]) = $img([expr $i - 1]) , img($i) = $img($i)"
		set FindRegisterVar(inimg1,addr) $img([expr $i - 1])
		set FindRegisterVar(inimg2,addr) $img($i)
		set FindRegisterVar(est_x_offset) $capture(frame${i},estx)
		set FindRegisterVar(est_y_offset) $capture(frame${i},esty)
		set results [Sadie_Proto_FindRegister FindRegisterVar]

		set registration(frame${i},x) [lindex $results 0]
		set registration(frame${i},y) [lindex $results 1]

		if {$registration(biasgain-adjust)} {
		    set registration(frame${i},gain) [lindex $results 3]
		    set registration(frame${i},bias) [lindex $results 2]
		} else {
		    set registration(frame${i},gain) 1.0
		    set registration(frame${i},bias) 0.0
		}

		puts "getting range..."
		set results [Sadie_TREES_GetRange $img($i)]
		set registration(frame${i},gmin) [lindex $results 0]
		set registration(frame${i},gmax) [lindex $results 1]

		Sadie_General_Close $img([expr $i - 1])
		unset img([expr $i - 1])
	    }
	    if {[info exists img([expr $capture(framecount) - 1])]} {
		Sadie_General_Close $img([expr $capture(framecount) - 1])
		unset img([expr $capture(framecount) - 1])
	    }
	    
	    if {$registration(illum-adjust)} {
		Sadie_General_Close $img(illum)
		unset img(illum)
	    }
	    
	    if {$gaugevar(cancel) != 0} {
		set registration(status) NONE
	    } else {
		set registration(status) COMPLETE
	    }


	}
    }

    if {[info exists CombineVar]} {
	unset CombineVar
    }
    if {[info exists FindRegisterVar]} {
	unset FindRegisterVar
    }

    if {$gaugenum != 0} {
        gauge_gui_delete $gaugenum
    }
        
    trees_update_status
}


proc trees_create_mosaic {} {
    global session capture registration mosaic noprompting labels findrings
    global gaugevar
    
    set gaugenum 0

    if {$registration(status) != "COMPLETE"} {
        messagebox "Mosaic Error" "Cannot create mosaic because frames are not registered."
        set mosaic(status) NONE
    } elseif {$capture(framecount) < 1} {
        messagebox "Mosaic Error" "Cannot create mosaic because one or more frames are not present."
        set mosaic(status) NONE
    } elseif {$mosaic(status) == "COMPLETE"} {
        messagebox "Mosaic Info" "Mosaic has already been created."
    } else {

        set gaugenum [gauge_gui_add "Mosaic Frames"]

        set mosaic(status) ACTIVE
        trees_update_status
        

        if {$gaugenum != 0} {gauge_gui_update $gaugenum 10}

        # Compute global registration parameters
	
        set mosaic(frame0,glob_x) 0
        set mosaic(frame0,glob_y) 0
        set mosaic(frame0,glob_bias) 0.0
        set mosaic(frame0,glob_gain) 1.0
        set gmin [expr ($registration(frame0,gmin) * $mosaic(frame0,glob_gain)) + $mosaic(frame0,glob_bias)]
        set gmax [expr ($registration(frame0,gmax) * $mosaic(frame0,glob_gain)) + $mosaic(frame0,glob_bias)]

        for {set i 1} {$i < $capture(framecount)} {incr i} {
            set mosaic(frame${i},glob_x) [expr $mosaic(frame[expr $i - 1],glob_x) + $registration(frame${i},x)]
            set mosaic(frame${i},glob_y) [expr $mosaic(frame[expr $i - 1],glob_y) + $registration(frame${i},y)]
            set mosaic(frame${i},glob_bias) [expr ($registration(frame${i},bias) * $mosaic(frame[expr $i - 1],glob_gain)) + $mosaic(frame[expr $i - 1],glob_bias)]
            set mosaic(frame${i},glob_gain) [expr $mosaic(frame[expr $i - 1],glob_gain) * $registration(frame${i},gain)]
            set gmin_temp [expr ($registration(frame${i},gmin) * $mosaic(frame${i},glob_gain)) + $mosaic(frame${i},glob_bias)]
            if {$gmin_temp < $gmin} {
                set gmin $gmin_temp
            }
            set gmax_temp [expr ($registration(frame${i},gmax) * $mosaic(frame${i},glob_gain)) + $mosaic(frame${i},glob_bias)]
            if {$gmax_temp > $gmax} {
                set gmax $gmax_temp
            }
        }

	puts "\n\n\n\n\n\n"
        for {set i 0} {$i < $capture(framecount)} {incr i} {
	    puts [format "%4d % 16.12f % 16.12f % 20.12f % 20.12f" $i $registration(frame${i},bias) $registration(frame${i},gain) $mosaic(frame${i},glob_bias) $mosaic(frame${i},glob_gain)]
	}
	puts "\n\n\n\n\n\n"
        
        if {$gaugenum != 0} {gauge_gui_update $gaugenum 20}
        if {$gaugevar(cancel) != 0} {
            if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
            set mosaic(status) "NONE"
            trees_update_status
            return;
        }

        puts "gmax = $gmax , gmin = $gmin"
        set mosaic(factor) [expr 254.0 / ($gmax - $gmin)]
        set mosaic(gmin) $gmin

        # Make sure that all global offsets are positive
	set negoff(x,exists) 0
	set negoff(x,max) 0
	set negoff(y,exists) 0
	set negoff(y,max) 0
        for {set i 0} {$i < $capture(framecount)} {incr i} {
	    if {$mosaic(frame${i},glob_x) < 0} {
		puts "mosaic(frame${i},glob_x) = $mosaic(frame${i},glob_x)"
		set negoff(x,exists) 1
		if {$mosaic(frame${i},glob_x) < $negoff(x,max)} {
		    set negoff(x,max) $mosaic(frame${i},glob_x)
		}
	    }

	    if {$mosaic(frame${i},glob_y) < 0} {
		puts "mosaic(frame${i},glob_y) = $mosaic(frame${i},glob_y)"
		set negoff(y,exists) 1
		if {$mosaic(frame${i},glob_y) < $negoff(y,max)} {
		    set negoff(y,max) $mosaic(frame${i},glob_y)
		}
	    }
	}
        if {$negoff(x,exists) > 0} {
            puts "Making global x offsets positive -- maxneg = $negoff(x,max)"

	    for {set i 0} {$i < $capture(framecount)} {incr i} {
		set mosaic(frame${i},glob_x) [expr $mosaic(frame${i},glob_x) - $negoff(x,max)]
	    }
        }  
        if {$negoff(y,exists) > 0} {
            puts "Making global y offsets positive -- maxneg = $negoff(y,max)"

	    for {set i 0} {$i < $capture(framecount)} {incr i} {
		set mosaic(frame${i},glob_y) [expr $mosaic(frame${i},glob_y) - $negoff(y,max)]
	    }
        }

	# Compute mosaic width and height
	set maxyoff 0
	set maxxoff 0
        for {set i 0} {$i < $capture(framecount)} {incr i} {
	    if {$mosaic(frame${i},glob_y) > $maxyoff} {
		set maxyoff $mosaic(frame${i},glob_y)
	    }
	    if {$mosaic(frame${i},glob_x) > $maxxoff} {
		set maxxoff $mosaic(frame${i},glob_x)
	    }
	}
	set mosaic(mosaicwidth) [expr $maxxoff + $capture(framewidth)]
	set mosaic(mosaicheight) [expr $maxyoff + $capture(frameheight)]
	puts "mosaic size: $mosaic(mosaicwidth)x$mosaic(mosaicheight)  --> maxxoff = $maxxoff, maxyoff = $maxyoff"



	# Compute calibration between mosaic coordinates and
	#  stage coordinates
#	set mosaic(stage_offset,x) [expr round($capture(frame0,stagex) - ($capture(framewidth) / 2.0) - $mosaic(frame0,glob_x))]
#	set mosaic(stage_offset,y) [expr round($capture(frame0,stagey) - ($capture(frameheight) / 2.0) - $mosaic(frame0,glob_y))]

	# This will allow the implementation of stage motion from the main TREES interface,
	#   by allowing a user to click the mouse on the browse mosaic and command the stage
	#   to move to that location.
	#
	# When user clicks on mosaic, if the mouse coordinates are mouse(x),mouse(y) within the raster
	#   mosaic (in full resolution coordinates), the corresponding stage coordinates will be:
	#      stage(x) = $mosaic(stage_offset,x) + $mouse(x)
	#      stage(y) = $mosaic(stage_offset,y) + $mouse(y)
	#
	# To move the stage, use: move_stage_to $stage(x) $stage(y)

	# Note that this will currently only work during the same session in which the frames
	#   were initially captured, since the stage coordinate system is reset each time the
	#   driver is reinitialized.  Thus, eventually the mosaic(stage_offset,x) and
	#   mosaic(stage_offset,y) need to be reset each time a session is restarted through
	#   some kind of a registration procedure where unique marks are identified on the
	#   wood sample.
	

	
	

	
        if {$gaugenum != 0} {gauge_gui_update $gaugenum 30}
        if {$gaugevar(cancel) != 0} {
            if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
            set mosaic(status) "NONE"
            trees_update_status
            return;
        }

        set mosaic(mosaicfile) "mosaic.SAD"
        set mosaic(indexfile) "index.SAD"

        set arguments $capture(framecount)
        set arguments [linsert $arguments end $mosaic(mosaicheight)]
        set arguments [linsert $arguments end $mosaic(mosaicwidth)]
        set arguments [linsert $arguments end $capture(frameheight)]
        set arguments [linsert $arguments end $capture(framewidth)]
        set arguments [linsert $arguments end $registration(illum-adjust)]
        set arguments [linsert $arguments end "$session(directory)/images/frames/$capture(illumination)"]
        set arguments [linsert $arguments end $mosaic(factor)]
        set arguments [linsert $arguments end $mosaic(gmin)]
        for {set i 0} {$i < $capture(framecount)} {incr i} {
            set arguments [linsert $arguments end "$session(directory)/images/frames/$capture(frame${i},file)"]
            set arguments [linsert $arguments end $mosaic(frame${i},glob_x)]
            set arguments [linsert $arguments end $mosaic(frame${i},glob_y)]
            set arguments [linsert $arguments end $mosaic(frame${i},glob_bias)]
            set arguments [linsert $arguments end $mosaic(frame${i},glob_gain)]
        }

        puts "Creating mosaic..."
        set results [eval Sadie_TREES_CreateMosaic $arguments]
        
        if {$gaugenum != 0} {gauge_gui_update $gaugenum 70}
        if {$gaugevar(cancel) != 0} {
            if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
            set mosaic(status) "NONE"
            trees_update_status
            return;
        }

        set mosaic(loaded,fullresol,mosaic) [lindex $results 0]
        set mosaic(loaded,fullresol,index) [lindex $results 1]
	set findrings(ring,resolution) 1

        set mosaic(file,mosaic) mosaicimg.SAD
        set mosaic(file,smallmosaic) mosaicimg_small.SAD
        set mosaic(file,index) mosaicimg.INDEX
	set mosaic(file,mosaic_columns) mosaic_columnsimg.SAD

        set mosaic(file,fullresol,mosaic) mosaicimg.SAD
        set mosaic(file,fullresol,index) mosaicimg.INDEX
	set mosaic(file,fullresol,mosaic_columns) mosaic_columnsimg.SAD
	
        Sadie_TREES_ByteSave $mosaic(loaded,fullresol,mosaic) $session(directory)/images/mosaic/$mosaic(file,fullresol,mosaic)
        Sadie_TREES_ByteMosaicExport $mosaic(loaded,fullresol,mosaic) $session(directory)/images/mosaic/$mosaic(file,fullresol,mosaic_columns)
        Sadie_TREES_MosaicIndexSave $mosaic(loaded,fullresol,index) $session(directory)/images/mosaic/$mosaic(file,fullresol,index)

        if {$gaugenum != 0} {gauge_gui_update $gaugenum 80}
        if {$gaugevar(cancel) != 0} {
            if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
            set mosaic(status) "NONE"
            trees_update_status
            Sadie_TREES_ByteClose $mosaic(loaded,fullresol,mosaic)
            Sadie_TREES_MosaicIndexClose $mosaic(loaded,fullresol,index)
            unset mosaic(loaded,fullresol,mosaic)
            unset mosaic(loaded,fullresol,index)
            return;
        }

        set mosaic(loaded,smallmosaic) [Sadie_TREES_ByteMosaicResamp $mosaic(loaded,fullresol,mosaic) $mosaic(loaded,fullresol,index) 6 6 6 6]
        Sadie_FileIO_Save $mosaic(loaded,smallmosaic) $session(directory)/images/mosaic/$mosaic(file,smallmosaic) 8

        if {$gaugenum != 0} {gauge_gui_update $gaugenum 90}
        if {$gaugevar(cancel) != 0} {
            if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
            set mosaic(status) "NONE"
            trees_update_status
            Sadie_TREES_ByteClose $mosaic(loaded,fullresol,mosaic)
            Sadie_TREES_MosaicIndexClose $mosaic(loaded,fullresol,index)
            unset mosaic(loaded,fullresol,mosaic)
            unset mosaic(loaded,fullresol,index)
            Sadie_General_Close $mosaic(loaded,smallmosaic)
            unset mosaic(loaded,smallmosaic)
            return;
        }



        set mosaic(status) "COMPLETE"
    }
    
    trees_update_status
	trees_autosave

    if {$gaugenum != 0} {gauge_gui_delete $gaugenum}
}
