proc trees_create_profilepanel {win} {
    frame ${win} \
        -borderwidth 2 \
        -relief ridge 
}

proc trees_destroy_profileplot {the_panel} {
    destroy ${the_panel}.xsb
    destroy ${the_panel}.profilecanvas
}

proc draw_profileplot {the_panel profile_list} {
    
    set xoffset 4
    set yoffset 4
    set scalef 3
    set levels 256
    set maxy [expr $levels / $scalef]
    set vsize [expr $maxy + (2 * $yoffset)]
    set ybase [expr $yoffset + $maxy]
    set nrings [llength profile_list]
    set npoints 0
    set profile_polys {}
    set ring_lines {}
    foreach ring $profile_list {
        set xpos [expr $xoffset + $npoints]
        incr npoints [llength $ring]
        set newpoly [list ${the_panel}.profilecanvas create polygon [expr $xpos/$scalef] $ybase]
        foreach pval $ring {
            lappend newpoly [expr $xpos/$scalef] [expr $pval / $scalef]
            incr xpos
        }
        incr xpos -1
        lappend newpoly [expr $xpos / $scalef]  $ybase -fill black
        lappend profile_polys $newpoly
        set linex [expr floor(0.5 + $xpos/$scalef)]
	lappend ring_lines [list ${the_panel}.profilecanvas create line $linex $ybase $linex $yoffset -fill green]
    }
    set hsize [expr ($npoints/$scalef) + (2 * $xoffset)]
    canvas ${the_panel}.profilecanvas -width $hsize -height $vsize \
        -scrollregion [list 0 0 $hsize $vsize] \
        -xscrollcommand [list  ${the_panel}.xsb set] \
        -confine true \
        -cursor left_ptr \
        -background white \
        -highlightthickness 0
    foreach poly $profile_polys {
        eval $poly
    }
    foreach rline $ring_lines {
        eval $rline
    }
    scrollbar ${the_panel}.xsb -orient horizontal \
        -background LightGray \
        -command [list ${the_panel}.profilecanvas xview]
    grid ${the_panel}.profilecanvas -column 0 -row 0 -sticky new
    grid ${the_panel}.xsb  -column 0 -row 1 -sticky new
    grid columnconfigure ${the_panel} 0 -weight 1
    grid rowconfigure ${the_panel} 0 -weight 1
}
