proc segmentation_creategui {win start_year end_year} {
     global SkelPlot measurements skelplot Image boundarycolor jion_flag Seg_jion_end1 Seg_jion_start2
     global SegstrVar guicount labels InsertVar DeleteVar Segstart Segend 
      
     set imagename "Segment\($start_year,$end_year\)_${InsertVar(outname)}${DeleteVar(outname)}${guicount}"
     set sadie_addr $guicount
     set out_title $imagename
     set photoname $win
 
     set imgarrayname [create_image_array $out_title $sadie_addr $photoname]
     insert_new_image $imgarrayname
     
     set Segstart($guicount)  $start_year 
     set Segend($guicount) $end_year
    
     # create the dispaly frame
     #
     toplevel $win -visual truecolor
     wm geometry $win +10+10
     wm protocol $win WM_DELETE_WINDOW {  
          set closewin [focus]
          set result [tk_dialog .dlg $labels(titles,exit) \
              "do you want close this segment session without saving" \
               question 0 "save and exit" "exit" ]
           if {$result} { 
           delete_segwindow $closewin
           } else { trees_save_segsession
                 delete_segwindow $closewin
            }
        }
    set screenwidth [winfo screenwidth .]
    set screenheight [winfo screenheight .]
    set startwidth [expr $screenwidth * 0.6]
    set startheight [expr $screenheight * 0.55]
    wm geometry $win [expr int($startwidth)]x[expr int($startheight)]
    wm maxsize $win [expr int($startwidth)] [expr int($startheight)]
    wm resizable $win 1 1
     #
     # create the display panel
     #
    frame ${win}.segmenubar
    trees_create_segmenubar $win.segmenubar.m  
    trees_create_segbuttonpanel $win.segbuttonpanel $start_year $end_year
    trees_create_profilepanel $win.profilepanel
    trees_create_skelplotpanel $win.skelplotpanel
    grid $win.segmenubar -row 0 -column 0  -columnspan 1 -sticky new
    grid $win.profilepanel -row 1 -column 0 -columnspan 5 -sticky new
    grid $win.segbuttonpanel -row 2 -column 0 -rowspan 3 -sticky nw
    grid $win.skelplotpanel -row 2 -column 1 -rowspan 1 -sticky nw
    
    #grid rowconfigure $win 0 -weight 0 
    #grid rowconfigure $win 0 -weight 1
    # grid rowconfigure $win 1 -weight 1
    incr guicount
if {!$jion_flag} {
    draw_subprofileplot $win.profilepanel $measurements(profiles) $start_year $end_year
    $win.skelplotpanel config -bg blue
     set seriesname "series"
     set SkelPlot(sample,$seriesname,color) $boundarycolor(timeseries)
     set SkelPlot(sample,$seriesname,invert) 0
     set skelplot(endyear) $end_year
      if {![info exists skelplot(endyear)]} {
               set skelplot(endyear) 0
            }

            # Initialize skelplot variables
      skelplot_init SkelPlot

            # Initialize Image variables
      image_init Image

            # Load the measured ringwidths
      load_subringwidth_series SkelPlot $measurements(ringwidth) $seriesname $start_year $end_year


      # Create mouse button-1 click binding for the browse image
      # to find coordinates and tags at click location
      bindMouseToImage SkelPlot Image .trees_main.imagepanel $seriesname canvas xsbar ysbar $SkelPlot(sample,$seriesname,masterlist)
   
            # Create initial skeleton plot canvas
      draw_skelplot SkelPlot $win.skelplotpanel topmarker timeseries $seriesname bottommarker xscr .trees_main.imagepanel.canvas
        
} else {
     draw_jion_subprofileplot $win.profilepanel $measurements(profiles) $start_year $Segend($InsertVar(inimg,addr1)) \
                              $Segstart($InsertVar(inimg,addr2)) $Segend($InsertVar(inimg,addr2))
     $win.skelplotpanel config -bg blue
     set seriesname "series"
     set SkelPlot(sample,$seriesname,color) $boundarycolor(timeseries)
     set SkelPlot(sample,$seriesname,invert) 0
     set skelplot(endyear) $end_year
     # [expr $Segend($InsertVar(inimg,addr2))+1+$Segend($InsertVar(inimg,addr1))-$Segstart($InsertVar(inimg,addr2))]
      if {![info exists skelplot(endyear)]} {
               set skelplot(endyear) 0
            }

            # Initialize skelplot variables
      skelplot_init SkelPlot

            # Initialize Image variables
      image_init Image

            # Load the measured ringwidths
      load_jion_subringwidth_series SkelPlot $measurements(ringwidth) $seriesname $start_year $Segend($InsertVar(inimg,addr1)) \
                                             $Segstart($InsertVar(inimg,addr2)) $Segend($InsertVar(inimg,addr2))


      # Create mouse button-1 click binding for the browse image
      # to find coordinates and tags at click location
      bindMouseToImage SkelPlot Image .trees_main.imagepanel $seriesname canvas xsbar ysbar $SkelPlot(sample,$seriesname,masterlist)
   
            # Create initial skeleton plot canvas
      draw_skelplot SkelPlot $win.skelplotpanel topmarker timeseries $seriesname bottommarker xscr .trees_main.imagepanel.canvas
      #unhighlight_image_ring .trees_main.imagepanel.canvas 1
     set jion_index [expr $guicount-1]
     set Seg_jion_end1($jion_index) $Segend($InsertVar(inimg,addr1))
     set Seg_jion_start2($jion_index) $Segstart($InsertVar(inimg,addr2))
     set jion_flag 0
     }
     $win.segbuttonpanel.default.bframe config -bg green
     $win.segbuttonpanel.timeseries.bframe config -bg red      
      #reset the orignal ringlist
     set skelplot(endyear) 0
     load_ringwidth_series SkelPlot $measurements(ringwidth) $seriesname
     update_segmenubar

}

proc trees_create_segbuttonpanel {win start_year end_year} {
    global SkelPlot

    frame ${win} -relief raised -borderwidth 2 -background LightGray
    pack ${win} -side top -fill x
    
    frame ${win}.default -relief flat -borderwidth 3 -background LightGray
    frame ${win}.default.bframe -relief flat -bg red -borderwidth 2 -background LightGray
    button ${win}.default.bframe.button -state normal -background LightGray\
      -command {                        set win [focus]
                                        set SkelPlot(sample,series,timeseries) 1
                                        draw_different_option 
                                        
                                        $win.segbuttonpanel.default.bframe config -bg green
                                        $win.segbuttonpanel.timeseries.bframe config -bg red
                                        $win.segbuttonpanel.early.bframe config -bg red
                                        $win.segbuttonpanel.late.bframe config -bg red
				}
    pack ${win}.default.bframe.button
    label ${win}.default.label -text "Timeseriese\nand Skelplot"  -bg LightGray -fg black
    pack ${win}.default.bframe ${win}.default.label -side top
    
    frame ${win}.timeseries -relief flat -borderwidth 3 -background LightGray
    frame ${win}.timeseries.bframe -relief flat -bg red -borderwidth 2 -background LightGray
    button ${win}.timeseries.bframe.button -state normal -background LightGray\
      -command {    set win [focus]
                    set SkelPlot(sample,series,timeseries) 2
                    draw_different_option
                    $win.segbuttonpanel.timeseries.bframe config -bg green
                    $win.segbuttonpanel.default.bframe config -bg red
                    $win.segbuttonpanel.late.bframe config -bg red
                    $win.segbuttonpanel.early.bframe config -bg red    
                }
    pack ${win}.timeseries.bframe.button
    label ${win}.timeseries.label -text "Timeseries\nonly" -bg LightGray -fg black
    pack ${win}.timeseries.bframe ${win}.timeseries.label -side top
    
    frame ${win}.early -relief flat -borderwidth 3 -background LightGray
    frame ${win}.early.bframe -relief flat -bg red -borderwidth 2
    button ${win}.early.bframe.button -state normal -background LightGray\
      -command {    set win [focus]
                    set SkelPlot(sample,series,timeseries) 3
                    draw_different_option
                    $win.segbuttonpanel.early.bframe config -bg green
                    $win.segbuttonpanel.timeseries.bframe config -bg red
                    $win.segbuttonpanel.default.bframe config -bg red
                    $win.segbuttonpanel.late.bframe config -bg red    
                }
    pack ${win}.early.bframe.button
    label ${win}.early.label -text "Early timeseries\nonly" -bg LightGray -fg black
    pack ${win}.early.bframe ${win}.early.label -side top

    frame ${win}.late -relief flat -borderwidth 3 -background LightGray
    frame ${win}.late.bframe -relief flat -bg red -borderwidth 2
    button ${win}.late.bframe.button -state normal -background LightGray\
      -command {    set win [focus]
                    set SkelPlot(sample,series,timeseries) 4
                    draw_different_option
                    $win.segbuttonpanel.late.bframe config -bg green
                    $win.segbuttonpanel.early.bframe config -bg red
                    $win.segbuttonpanel.timeseries.bframe config -bg red
                    $win.segbuttonpanel.default.bframe config -bg red
                }
    pack ${win}.late.bframe.button
    label ${win}.late.label -text "Late timeseries\nonly" -bg LightGray -fg black
    pack ${win}.late.bframe ${win}.late.label -side top 
    
    #pack ${win}.default ${win}.timeseries ${win}.early ${win}.late -side left  
    grid ${win}.default -sticky news
    grid ${win}.timeseries -sticky news
    grid ${win}.early -sticky news
    grid ${win}.late -sticky news
}
proc trees_create_segmenubar {win} {
     global labels


    frame ${win} -relief raised -borderwidth 2 -background LightGray
    pack ${win} -padx 0 -pady 0
    
    menubutton ${win}.file -bg LightGray -fg #B80000\
	    -textvariable labels(file,title) -menu ${win}.file.menu
    menu ${win}.file.menu -tearoff 0
    
    pack ${win}.file -side left
    # File Menu
    ${win}.file.menu add command -label save -background LightGray -foreground #0000C8\
	    -command  { trees_save_segsession
     }
   ${win}.file.menu add separator -background LightGray 

   ${win}.file.menu add command -label $labels(menu,file,exit) -background LightGray -foreground #0000C8\
	   -command {
          set closewin [focus]   
          set result [tk_dialog .dlg $labels(titles,exit) \
			"do you want close this segment session without saving" \
			question \
			0 "save and exit" "exit" ]
           if {$result} { 
           delete_segwindow $closewin
           } else { trees_save_segsession
                 delete_segwindow $closewin
            }
    }

}
proc trees_save_segsession {} {
     global filemarker filemarker_family labels session capture registration mosaic findrings measurements skelplot SkelPlot
     global Segstart Segend guicount global_endyear Seg_jion_end1 Seg_jion_start2
     set ring_length [expr [llength $measurements(ringwidth)]-1]
    # get filename to save
    set types {
        {{TREES Data Files} {.tdf}        }
        {{All Files}        *             }
    }
    set filename [tk_getSaveFile -filetypes $types]
    
    if {$filename != ""} then {
       
        set slectforcus [focus]
        if {$guicount>10} { 
        set inter_number [string range $slectforcus end-1 end]
        } else {set inter_number [string index $slectforcus end] }
    
        set offset 0
        set select_number [expr $inter_number + $offset]
        #puts "select_number in button push is: $select_number"
        set start $Segstart($select_number)
        set end $Segend($select_number)
        set seriesname "series"
        set skelplot(endyear) [expr $end+$global_endyear-$ring_length]
        load_subringwidth_series SkelPlot $measurements(ringwidth) $seriesname $start $end
    if {[string match *jion_* $slectforcus]} {
       set start1 $start
       set end1  $Seg_jion_end1($select_number) 
       set start2 $Seg_jion_start2($select_number)
       set end2 [expr $end+$Seg_jion_start2($select_number)-$Seg_jion_end1($select_number)-1]
       puts "demension of seg1 and seg2: $start1 $end1 $start2 $end2 "
       load_jion_subringwidth_series SkelPlot $measurements(ringwidth) $seriesname $start $Seg_jion_end1($select_number)\
                                              $Seg_jion_start2($select_number) $end2

       }
        # open file for save
        set fileid [open $filename "w" 0666]

        # save name
        puts $fileid $filemarker

        puts $fileid "\# DO NOT MODIFY THIS FILE!"
        puts $fileid "\# It was generated automatically by TREES v2.0"
        puts $fileid "\#"

        puts $fileid "\#Session info"
        set session(notes) [split $session(notes) \n]
        puts $fileid [get_sorted_array session]
        set session(notes) [join $session(notes) \n]

        puts $fileid "\#Capture info"
        puts $fileid [get_sorted_array capture]

        puts $fileid "\#Registration info"
        puts $fileid [get_sorted_array registration]

        puts $fileid "\#Mosaic info"
        puts $fileid [get_sorted_array mosaic]

        puts $fileid "\#Ring identification info"
        puts $fileid [get_sorted_array findrings]

        puts $fileid "\#Measurement info"
        puts $fileid [get_sorted_array measurements]

        puts $fileid "\#Skeleton plot info"
        puts $fileid [get_sorted_array skelplot]
        
        puts $fileid "\#Export Skeleton plot info"
        if {$skelplot(status) == "COMPLETE"} {
           createPlotFileData $SkelPlot(sample,series,serieslist)
        } 
        puts $fileid [get_sorted_array plotdata]
        
        # close file
        close $fileid
        #reset to the orignal data
        set skelplot(endyear) 0
        load_ringwidth_series SkelPlot $measurements(ringwidth) $seriesname
    } else {
        puts "save segment session  error"
    }
}


proc draw_different_option {} {
    global Segstart Segend measurements SkelPlot boundarycolor skelplot Image guicount
    set slectforcus [focus]
    if {$guicount>10} { 
      set inter_number [string range $slectforcus end-1 end]
    } else {set inter_number [string index $slectforcus end] }
    
    set offset 0
    set select_number [expr $inter_number + $offset]
    puts "select_number in button push is: $select_number"
    set start $Segstart($select_number)
    set end $Segend($select_number)
    set win $slectforcus
    set seriesname "series"
   
    # Load the measured ringwidths   
    if {$SkelPlot(sample,series,timeseries)==3} {
      set skelplot(endyear) $end
      load_subringwidth_series SkelPlot $measurements(earlywidth) $seriesname $start $end
      redraw_skelplot SkelPlot $win.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas
     
      #reset the orignal ringlist
      set skelplot(endyear) 0
      load_ringwidth_series SkelPlot $measurements(ringwidth) $seriesname
    } elseif {$SkelPlot(sample,series,timeseries)==4} {
       set skelplot(endyear) $end
      load_subringwidth_series SkelPlot $measurements(latewidth) $seriesname $start $end
      redraw_skelplot SkelPlot $win.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas
     
      #reset the orignal ringlist
       set skelplot(endyear) 0
      load_ringwidth_series SkelPlot $measurements(ringwidth) $seriesname
    } else {
      set skelplot(endyear) $end
     load_subringwidth_series SkelPlot $measurements(ringwidth) $seriesname $start $end

     redraw_skelplot SkelPlot $win.skelplotpanel topmarker timeseries series bottommarker xscr .trees_main.imagepanel.canvas
     
      #reset the orignal ringlist
       set skelplot(endyear) 0
      load_ringwidth_series SkelPlot $measurements(ringwidth) $seriesname
    }
}


proc draw_subprofileplot {the_panel profile_list start_year end_year} {
    set subprofile_list {{}}
    set nring 0
    incr end_year
    foreach ring $profile_list {
	if {$nring >= $start_year } {
	    if {$nring < $end_year} {    
       lappend subprofile_list $ring
	  }
      }
    incr nring
    }
    draw_profileplot $the_panel $subprofile_list 
}

proc draw_jion_subprofileplot {the_panel profile_list start1 end1 start2 end2} {
    set subprofile_list {{}}
    set nring 0
    
    foreach ring $profile_list {
        set condition [expr [expr $nring >= $start1 && $nring <= $end1]||[expr $nring >= $start2 && $nring <= $end2]]
	if {$condition} {  
       lappend subprofile_list $ring
      }
    incr nring
    }
    draw_profileplot $the_panel $subprofile_list 
}

proc load_subringwidth_series { var widthlist name start_year end_year } {
    set sub_widthlist {}
    set nring 0
    foreach ring $widthlist {
	if {$nring >= $start_year } {
	    if {$nring <= $end_year} {    
       lappend sub_widthlist $ring
	  }
      }
     incr nring
    }
   load_ringwidth_series $var $sub_widthlist $name  
}

proc load_jion_subringwidth_series {var widthlist name start1 end1 start2 end2} {
    set sub_widthlist {}
    set nring 0
    foreach ring $widthlist {
    set condition [expr [expr $nring >= $start1 && $nring <= $end1]||[expr $nring >= $start2 && $nring <= $end2]]
	if {$condition} {    
       lappend sub_widthlist $ring
      }
     incr nring
    }
   load_ringwidth_series $var $sub_widthlist $name  
} 

proc seg_preference_dialog {} {
     global jion_gap_thr confirmStatus measurements
      # Create the dialog 
    set temp 5
    #set ring_length [expr [llength $measurements(ringwidth)]-1]
    set top [seg_dialog_create Dialog .segpreferencedlg]
    wm geometry $top +110+110
    wm title $top "set segment preference parameter dialog"
    wm protocol $top WM_DELETE_WINDOW {dialog_set_confirm 0}
    bind $top <Return> {dialog_set_confirm 1}
    #
    # Create the dialog input section
    #
    set input [dialog_input $top]
   

    set row {}
    lappend row {radiobutton "Set prefer gap threshold " SegstrVar(type) 1}
    lappend row {label "Set a new threshold\n \(must be less than the ring length\)" }
    lappend row {entry jion_gap_thr}
    
    dialog_create_stdrow $input 0 $row

    grid columnconfigure $input 2 -minsize 80
    
   
    # Create the dialog controls
    #
    set cntls [dialog_controls $top]
    dialog_buttons $cntls {dialog_set_confirm 1} {dialog_set_confirm 0}
   
    # Wait for a response
    #
    dialog_wait $top confirmStatus
    
    if {$confirmStatus == 1} {
        
        destroy $top.input
        destroy $top.cntls
        destroy $top
    } else {
        set jion_gap_thr $temp
        destroy $top.input
        destroy $top.cntls
        destroy $top
    }
    destroy $top
}

proc segmentselect_dialog { } {
   
    global confirmStatus guicount SegstrVar measurements flag
    #if {$guicount>=1} {
    #unhighlight_selction  $SegstrVar(start) $SegstrVar(end)
    #}
    # Create the dialog 
    
    set top [seg_dialog_create Dialog .segmentselectdlg]
    wm geometry $top +110+110
    wm title $top "segmentselect_dialog"
    wm protocol $top WM_DELETE_WINDOW {dialog_set_confirm 0}
    bind $top <Return> {dialog_set_confirm 1}
    
   

    #
    # Create the dialog input section
    #
    set input [dialog_input $top]

   
    
    
    set row {}
    lappend row {radiobutton "Selct ROI    " SegstrVar(type) 0}
   #lappend row {entry 1}
   #lappend row [subst {label \"$LinearstrVar(minbiaslbl)\" LinearstrVar(minbiaslbl)}]
     dialog_create_stdrow $input 0 $row

    set row {}
    lappend row {radiobutton "Select Years Interested    " SegstrVar(type) 1}
    lappend row {label "Start Year" }
    lappend row {entry  SegstrVar(start)}
    lappend row {label "End Year" }
    lappend row {entry  SegstrVar(end)}
   #lappend row [subst {label \"$LinearstrVar(maxgainlbl)\" LinearstrVar(maxgainlbl)}]
    dialog_create_stdrow $input 1 $row

    grid columnconfigure $input 2 -minsize 80
    
   
    # Create the dialog controls
    #
    set cntls [dialog_controls $top]
    dialog_buttons $cntls {dialog_set_confirm 1} {dialog_set_confirm 0}
   
    # Wait for a response
    #
    dialog_wait $top confirmStatus
    
if {$confirmStatus && $SegstrVar(type)} {
   if {$confirmStatus} {
    set ring_length [expr [llength $measurements(ringwidth)]-1]
    set ring_range_status [expr $SegstrVar(end) <= $ring_length && $SegstrVar(end)>=0 \
                            && $SegstrVar(start) <= $ring_length && $SegstrVar(start)>=0\
                            && $SegstrVar(start) < $SegstrVar(end)]
    
    if {$confirmStatus == 1 && $ring_range_status} {
        segmentation_run
        destroy $top.input
        destroy $top.cntls
        destroy $top
    } elseif {!$ring_range_status && $confirmStatus==1 } {
     destroy $top.input
     destroy $top.cntls
      destroy $top
     set result [tk_dialog .dlg "Select Error" \
			"The Selected segment should be a decimal number and located \
                          in the Range of the rings: \[0,$ring_length\]!!\n And the start year should be less than the end year\
                         \n Please Try again" \
			question \
			0 "Select new segment" "cancel" ]
           if {!$result} { 
            segmentselect_dialog
           } 
       } else {
        destroy $top.input
     destroy $top.cntls
      destroy $top
    }
    } else {destroy $top.input
     destroy $top.cntls
      destroy $top }
    destroy $top
  } elseif {$confirmStatus && !$SegstrVar(type)} {
# select ROI
  global roi_minx roi_miny roi_maxx roi_maxy
   set flag 0
   trees_roi $flag
   vwait roi(selected)
   set flag 1
  
  segmentation_run
  
  } elseif {!$confirmStatus} {
     destroy $top.input
     destroy $top.cntls
     destroy $top
}
}

proc Insert_segment_dialog {} {
     global InsertVar
     global confirmStatus
     
     # initialize the dialog varaibles
    set InsertVar(inimg,addr1) "none"
    set InsertVar(inimg,addr2) "none"
    set InsertVar(outname) "Join"
   
   #
    # Create the dialog 
    #
    set top [seg_dialog_create Dialog .insertdlg]
    wm geometry $top +110+110
    wm title $top "Insert Dialog"
    wm protocol $top WM_DELETE_WINDOW {dialog_set_confirm 0}
    bind $top <Return> {dialog_set_confirm 1}
    
    #
    # Create the dialog title section
    #
    set title [dialog_title $top]
    label $title.titlelbl -text "Insert one segment after Another"
    grid $title.titlelbl -sticky news

    #
    # Create the dialog input section
    #
    set input [dialog_input $top]

    set row {}
    lappend row {label "Start segment: "}
    lappend row {imgchooser InsertVar(inimg,addr1) 0 4}
    dialog_create_stdrow $input 0 $row

    set row {}
    lappend row {label "End segment: "}
    lappend row {imgchooser InsertVar(inimg,addr2) 1 4}
    dialog_create_stdrow $input 1 $row

   

    #
    # Create the dialog output section
    #
    set row {}
    lappend row {label "Output Segment Name: "}
    lappend row {entry InsertVar(outname)}
    dialog_create_stdrow $input 2 $row
    
    #
    # Create the dialog controls
    #
    set cntls [dialog_controls $top]
    dialog_buttons $cntls {dialog_set_confirm 1} {dialog_set_confirm 0}
    
    
    #
    # Wait for a response
    #
    dialog_wait $top confirmStatus

    destroy $top
    
    if {$confirmStatus == 1} {
        insert_segment_run
        destroy $top    
    } else {destroy $top}
} 

proc Delete_segment_dialog {} {
     global DeleteVar
     global confirmStatus
     
     # initialize the dialog varaibles
    set DeleteVar(inimg,addr1) "none"
    set DeleteVar(inimg,addr2) "none"
    set DeleteVar(outname) "Deleted_Segment"
   
   #
    # Create the dialog 
    #
    set top [seg_dialog_create Dialog .deletedlg]
    wm geometry $top +110+110
    wm title $top "Delete Dialog"
    wm protocol $top WM_DELETE_WINDOW {dialog_set_confirm 0}
    bind $top <Return> {dialog_set_confirm 1}
    
    #
    # Create the dialog title section
    #
    set title [dialog_title $top]
    label $title.titlelbl -text "Delete one segment from Another"
    grid $title.titlelbl -sticky news

    #
    # Create the dialog input section
    #
    set input [dialog_input $top]

    set row {}
    lappend row {label "Background segment: "}
    lappend row {imgchooser DeleteVar(inimg,addr1) 0 4}
    dialog_create_stdrow $input 0 $row

    set row {}
    lappend row {label "Foreground segment: "}
    lappend row {imgchooser DeleteVar(inimg,addr2) 1 4}
    dialog_create_stdrow $input 1 $row

   

    #
    # Create the dialog output section
    #
    set row {}
    lappend row {label "Output Segment Name: "}
    lappend row {entry DeleteVar(outname)}
    dialog_create_stdrow $input 2 $row
    
    #
    # Create the dialog controls
    #
    set cntls [dialog_controls $top]
    dialog_buttons $cntls {dialog_set_confirm 1} {dialog_set_confirm 0}
    
    
    #
    # Wait for a response
    #
    dialog_wait $top confirmStatus

    destroy $top
    
    if {$confirmStatus == 1} {
        Delete_segment_run
        destroy $top    
    } else {destroy $top}
}

proc Delete_segment_run {} {
    global SegstrVar guicount DeleteVar
    global flag roi SkelPlot Segstart Segend
    set local_start 0
    set local_end 0
    set InsertVar(outname) "" 
   set end_location [expr $Segstart($DeleteVar(inimg,addr1)) < $Segstart($DeleteVar(inimg,addr2))] 
   set front_location [expr $Segend($DeleteVar(inimg,addr1)) > $Segend($DeleteVar(inimg,addr2))]
   set same_front [expr $Segstart($DeleteVar(inimg,addr1)) ==  $Segstart($DeleteVar(inimg,addr2))]
   set same_end [expr $Segend($DeleteVar(inimg,addr1)) == $Segend($DeleteVar(inimg,addr2))]
   if {$end_location&&$same_end} {
         set local_start $Segstart($DeleteVar(inimg,addr1))
         set local_end  $Segstart($DeleteVar(inimg,addr2))
    set win ".segmentationgui_${DeleteVar(outname)}${guicount}"
    highlight_selction $local_start $local_end
    segmentation_creategui $win $local_start $local_end 
  
    } elseif {$front_location&&$same_front} {
         set local_start $Segend($DeleteVar(inimg,addr2))
         set local_end $Segend($DeleteVar(inimg,addr1))
    set win ".segmentationgui_${DeleteVar(outname)}${guicount}"
    highlight_selction $local_start $local_end
    segmentation_creategui $win $local_start $local_end 
  
    } else {
            set result [tk_dialog .dlg "Delete Error" \
			"The Deleted segment should be located in the very end or\
                 start of the Background segment!! Please Try again" \
			question \
			0 "Select new segment" "cancel" ]
            if {!$result} { 
             segmentselect_dialog
           } 
      }
}

proc dialog_title {win} {
    return "$win.title"
}
proc dialog_controls {win} {
    return "$win.controls"
}

proc insert_segment_run {} {
    global SegstrVar guicount InsertVar jion_flag
    global flag roi SkelPlot Segstart Segend jion_gap_thr
    set DeleteVar(outname) ""
    set end_year [expr $Segend($InsertVar(inimg,addr2))-$Segstart($InsertVar(inimg,addr2))+$Segend($InsertVar(inimg,addr1))+1]
   set separate_condition [expr [expr $Segend($InsertVar(inimg,addr1)) < $Segstart($InsertVar(inimg,addr2))]||\
                                [expr $Segend($InsertVar(inimg,addr2)) < $Segstart($InsertVar(inimg,addr1))]]  
   set front_condition [expr $Segstart($InsertVar(inimg,addr1)) < $Segstart($InsertVar(inimg,addr2))]
   set gap_condition  [expr [expr $Segstart($InsertVar(inimg,addr2))-$Segend($InsertVar(inimg,addr1))]<=$jion_gap_thr]
   if {$front_condition&&$separate_condition} {     
       if {$gap_condition} {
    set jion_flag 1 
    set win ".segmentationgui_jion_${InsertVar(outname)}${guicount}"
    highlight_selction $Segstart($InsertVar(inimg,addr1)) $Segend($InsertVar(inimg,addr2))
    segmentation_creategui $win $Segstart($InsertVar(inimg,addr1)) $end_year
       } else {
             set result4 [tk_dialog .dlg "Jion Error" \
			"The two jioned segments have a too wide gap (>5), it must be less than the threshold (5)\
                         !!\n Please Try again" \
			question \
			0 "Select new segment" "cancel" ]
            if {!$result4} { 
             segmentselect_dialog
           }      
            }   
    } elseif {$front_condition} {
      set result1 [tk_dialog .dlg "Jion Error" \
			"The two jioned segments should not be overlapped\
                         !!\n Please Try again" \
			question \
			0 "Select new segment" "cancel" ]
            if {!$result1} { 
             segmentselect_dialog
           }     
   
  
       } elseif {$separate_condition} {
            set result2 [tk_dialog .dlg "Jion Error" \
			"The start segment should be in the front of the end segment !!\
                         \nPlease Try again" \
			question \
			0 "Jion two segment" "cancel" ]
            if {!$result2} { 
             Insert_segment_dialog
           } 
       } else {
            set result3 [tk_dialog .dlg "Jion Error" \
			"The start segment should be in the front of the end segment and \
                         The two jioned segments should not be overlapped !!\
                         \nPlease Try again" \
			question \
			0 "Select new segment" "cancel" ]
            if {!$result3} { 
             segmentselect_dialog
        }
    }
       
}

proc segmentation_run {} {
 global SegstrVar guicount measurements
 global roi_minx roi_miny roi_maxx roi_maxy
 global flag roi SkelPlot SadieVar InsertVar DeleteVar
 set win ".segmentationgui$guicount"
 set InsertVar(outname) ""
 set DeleteVar(outname) ""



 
   if {!$SegstrVar(type)} {
   # select rings from ROI
    global ROI_start_year ROI_end_year
    
    set ROI_start_year 0
    set ROI_end_year 0
    Get_start_fromROI $measurements(boundbox) $roi_minx $roi_miny $roi_maxx $roi_maxy
    set Segstart($guicount)  $ROI_start_year 
    set Segend($guicount) $ROI_end_year
    highlight_selction $ROI_start_year $ROI_end_year
    segmentation_creategui $win $ROI_start_year $ROI_end_year       
    } else {
       #select rings from year number
        set Segstart($guicount)  $SegstrVar(start) 
        set Segend($guicount) $SegstrVar(end)
        highlight_selction $Segstart($guicount) $Segend($guicount)
        segmentation_creategui $win $Segstart($guicount) $Segend($guicount) 
    }
}

proc Get_start_fromROI { boundbox_list minx miny maxx maxy} {
     global ROI_start_year ROI_end_year
     set i 0
     set first_flag 1
     set ring_num -1
     set div_factor 4
     set minx_flag 0
     set miny_flag 0
     set maxx_flag 0
     set maxy_flag 0    
     foreach ring_box $boundbox_list {
         set rem [expr round(fmod($i,$div_factor))]
         
	 switch -exact -- $rem {
	     0 {
                incr ring_num
		if {$ring_box >= $minx} { set minx_flag 1 }
                 #puts "minx_flag is:$minx_flag " 
                }
             1 {
                if {$ring_box >= $miny} { set miny_flag 1 }  
                 #puts "miny_flag is:$miny_flag "
               }
	     2 {
                if {$ring_box <= $maxx} { set maxx_flag 1 } 
                 #puts "maxx_flag is:$maxx_flag "
               }
	     3 {
                if {$ring_box <= $maxy} { set maxy_flag 1 } 
                 #puts "maxy_flag is:$maxy_flag "
                if {$minx_flag && $miny_flag && $maxx_flag && $maxy_flag && $first_flag } {
                   set ROI_start_year $ring_num
                   set first_flag 0
                 
		} elseif {$minx_flag && $miny_flag && $maxx_flag && $maxy_flag} {
                         set ROI_end_year [expr $ring_num-1]
                        
                        }
                set minx_flag 0
                set miny_flag 0
                set maxx_flag 0
                set maxy_flag 0
               }
        }
        incr i
    }
 
}

proc create_image_selector {button_name variable_name {index "none"} {imgnum 0}} {
    global SadieVar    
    
    #
    # Create the widget
    #
    set m "${button_name}.menu"
    menubutton $button_name -menu $m -relief raised -borderwidth 3 \
        -justify left -anchor w
    menu $m -tearoff 0
    
    foreach imagename $SadieVar(imagelist) {
        upvar #0 $imagename imgarray
        
        $m add command -label $imgarray(title) \
            -command "update_image_selector $button_name $variable_name \
                $index \"$imgarray(title)\" $imgarray(sadie_addr)"
        
    }
    
    #
    # Initialize the widget
    #
    if {[llength $SadieVar(imagelist)] < [expr $imgnum + 1]} {
        set imgnum 0
    }
    
    upvar #0 [lindex $SadieVar(imagelist) $imgnum] imgarray
    $button_name configure -text $imgarray(title)
    upvar #0 $variable_name var
    if {$index != "none"} {
        set var($index) $imgarray(sadie_addr)
    } else {
        set var $imgarray(sadie_addr)
    }
}

#
# update_image_selector --
#
#       Update an image selection widget.
#
# Arguments:
#       button_name -- The name of the widget.
#       variable_name -- The name of the global variable in
#           which to store image sadie address.
#       index -- If $variable_name is an array, this is its
#           index.
#       title -- The title of the image that is to be made
#           active.
#       address -- The sadie address of the image that is
#           to be made active.
#
# Results:
#       The image selection widget is updated by setting the 
#       label of the button to $title and the value of 
#       $variablename($index) to $address.
#
proc update_image_selector {button_name variable_name index title address} {
    $button_name configure -text $title
    
    upvar #0 $variable_name var
    if {$index != "none"} {
        set var($index) $address
    } else {
        set var $address
    }
}

#
# insert_new_image --
#
#       Insert a new image information array into a list of
#       active images.
#
# Arguments:
#       imgName -- The name of the global image information array
#
# Results:
#       The result is that the image information array is inserted
#       at the top of the image list.  This image will be the
#       "current" image.
#
proc insert_new_image {imgName} {
    global SadieVar
      
    if {[lsearch -exact $SadieVar(imagelist) $imgName] < 0} {
        #unhighlight_current_image
        set SadieVar(imagelist) [linsert $SadieVar(imagelist) 0 $imgName]
    } else {
        error "The image array \"$imgName\" is already included in the global image list"
    }
}


#
# create_image_array --
#
#       Create a new image information array.
#
# Arguments:
#       imgTitle -- The title of the image
#       sadieAddr -- The address of the SADIE image
#       photoName -- The name of the tk_photo for displaying
#           the SADIE image
#       imgName -- The name of the global image information array
#       imgWindow -- The name of the Tk window in which to
#           display the image
#
# Results:
#       A global image information array is created and
#       initialized.  The name of the array is returned.
#
proc create_image_array { imgTitle sadieAddr photoName {imgName "auto"} } {
    global SadieVar
    
   if {$imgName == "auto"} {
        set count 0
        set imgName "imgarr[incr count]"
        global $imgName
        while {[info exists $imgName]} {
            set imgName "imgarr[incr count]"
            global $imgName
        }
    }
    upvar #0 $imgName imgarray

    # The SADIE address of the image
    set imgarray(sadie_addr) $sadieAddr

    # The name of the Tk window to display the image
   # set imgarray(window) $imgWindow
    
    # The title of the image
    set imgarray(title) $imgTitle
    
    # The Tk photo name of the original display image
    set imgarray(tk_photo) $photoName

    # The Tk photo name of the zoomed display image
    #set imgarray(tk_photo_zoom) [image create photo]

    # The zoom value for the displayed image
    #set imgarray(zoom) 1
    
    # The scaling value for the displayed image
    # Always turn on scaling by default for a new image
    #set SadieVar(getstretched) 1
    #set imgarray(scaling) $SadieVar(getstretched)
    
    # The number of bands in the SADIE image
    #set imgarray(bands) [Sadie_General_GetNumBands $imgarray(sadie_addr)]
    
    # The number of defined regions in the image
    #set imgarray(region,count) 0

    # Indicator of whether to show the defined regions
   # set imgarray(showregions) 0

    # The number of defined classes in the image
    #set imgarray(class,count) 0
    
    # The number of defined control points in the image
    #set imgarray(ctrlpt,count) 0

    # Indicator of whether to show the defined control points
    #set imgarray(showctrlpts) 1

    return $imgName
}

proc delete_segwindow {win} {
    global SadieVar guicount
    
    set inter_number [string index $win end]
    set offset 1
    if {$guicount>10} { 
      set inter_number [string range $win end-1 end]
    } else {set inter_number [string index $win end] }
    set select_number [expr $inter_number + $offset]
   # puts "select_number is: $select_number"
    set imgname "imgarr${select_number}"
    set imgname_index [lsearch -exact $SadieVar(imagelist) $imgname]

    # destroy segment session window
    destroy $win
    #delete the tiltle from dialog list/menu
    #puts "SadieVar(imagelist) is: $SadieVar(imagelist)"
    #remove the image array name from the global image list
    set SadieVar(imagelist) [lreplace $SadieVar(imagelist) $imgname_index $imgname_index]   
    #$SadieVar(imagelist) delete $imgname
    unset imgname
    update_segmenubar
}

proc update_segmenubar {} {
 global labels SadieVar 
 #update menubar entry  
  if {[llength $SadieVar(imagelist)]==0} {
       .trees_main.menubar.m.segmentation.menu entryconfigure $labels(menu,segmentation,Insertsegment) -state disable
       .trees_main.menubar.m.segmentation.menu entryconfigure $labels(menu,segmentation,Deletesegment) -state disable
    } else {
       .trees_main.menubar.m.segmentation.menu entryconfigure $labels(menu,segmentation,Insertsegment) -state normal
       .trees_main.menubar.m.segmentation.menu entryconfigure $labels(menu,segmentation,Deletesegment) -state normal
    }

}

proc highlight_selction {start end} {
  global SkelPlot
  set seriesname "series"
   
  unhighlight_image_ring .trees_main.imagepanel.canvas 0  
  
  for {set i $start} {$i <= $end} {incr i 2} {  
  highlight_image_ring .trees_main.imagepanel.canvas $i $SkelPlot(sample,$seriesname,serieslist)
    }
}

proc unhighlight_selction {start end} {
  #global SkelPlot
  set seriesname "series"
    for {set i $start} {$i <= $end} {incr i 2} {  
    unhighlight_image_ring .trees_main.imagepanel.canvas $i
    }
}



#
# dialog_wait --
#
#       Lock the program until user responds to the dialog.
#
# Arguments:
#       win -- The name of the toplevel window
#       varName -- Name of variable to monitor
#
# Results:
#       Grabs control of the window manager until $varName
#       is written to.
#
proc dialog_wait {win varName} {
    dialog_safeguard $win

    set x [expr [winfo rootx .]+50]
    set y [expr [winfo rooty .]+50]
    wm geometry $win "+$x+$y"

    wm deiconify $win
    
    set cmd {grab set $win}

    tkwait visibility $win

    if {[catch $cmd err] != 0} {
        global errorInfo
        set savedInfo $errorInfo
        
        destroy $win
        
        error $err $savedInfo
    }

    vwait $varName

    set cmd {grab release $win}
    if {[catch $cmd err] != 0} {
        global errorInfo
        set savedInfo $errorInfo
        
        destroy $win
        
        error $err $savedInfo
    }

    wm withdraw $win




bind modalDialog <ButtonPress> {
    wm deiconify %W
    raise %W
}
}

#
# dialog_buttons --
#
#       Create a standard set of buttons for each dialog
#       in tclSadie.
#
# Arguments:
#       win -- The name of the toplevel window
#       okcmd -- The command to call if "OK" is pressed
#       cancelcmd -- The command to call if "Cancel" 
#           is pressed
#       helpcmd -- The command to call if "Help" is pressed
#
# Results:
#       Creates "OK", "Help", and "Cancel" buttons and
#       packs them vertically.
#
proc dialog_buttons {win okcmd cancelcmd {helpcmd "none"}} {
    button $win.ok -text "OK" -command $okcmd
    
    button $win.cancel -text "Cancel" -command $cancelcmd
    
    button $win.help -text "Help" -command $helpcmd
    if {$helpcmd == "none"} {
        $win.help configure -state disabled
    }
    
    grid $win.ok -pady 5 -padx 5 -sticky ew
    grid $win.cancel -pady 5 -padx 5 -sticky ew
    grid $win.help -pady 5 -padx 5 -sticky ew

    focus $win.ok

    wm protocol [winfo toplevel $win] WM_DELETE_WINDOW "$win.cancel invoke"
}

#
# dialog_set_confirm --
#
#       Set the confirmStatus variable.
#
# Arguments:
#       status -- Value to set variable to.
#
# Results:
#       Sets the confirmStatus variable, which should
#       triger a modal dialog to continue.
#
proc dialog_set_confirm {status} {
    global confirmStatus
    
    set confirmStatus $status
}




proc dialog_create_stdrow {win row typelist} {
    set column 0
    set sticky w
    set pady 2
    set padx 0

    foreach element $typelist {
	set span 1
	set usevar 0
	set usecmd 0

	set numargs [llength $element]
	set type [lindex $element 0]

	switch $type {
	    label {
		if {$numargs < 2} {
		    error "wrong number of args for type $type:  should be \"$type text \[variable\] \[span\]\""
		}

		set text [lindex $element 1]
		if {$numargs > 2} {
		    set variable [lindex $element 2]
		    if {$variable != "none"} {
			set usevar 1
		    }
		}
		if {$numargs > 3} {
		    set span [lindex $element 3]
		}

		set name ${win}.item${row}_$column
		if {$usevar} {
		    label $name -text $text -textvariable $variable
		} else {
		    label $name -text $text
		}
		grid $name -row $row -column $column -columnspan $span -padx $padx -pady $pady -sticky $sticky
	    }

	    imgchooser {
		set imgnum 0
		set index none
		
		if {$numargs < 2} {
		    error "wrong number of args for type $type:  should be \"$type variable [imgnum] \[span\]\""
		}

		set var [lindex $element 1]
		# If the variable is an array, parse into variable and index names
		set isarray [regexp {([^\(]*)\(([^\)]*)\)$} $var match var index]

		if {$numargs > 2} {
		    set imgnum [lindex $element 2]
		}
		if {$numargs > 3} {
		    set span [lindex $element 3]
		}

		set name ${win}.item${row}_$column
		create_image_selector $name $var $index $imgnum
		grid $name -row $row -column $column -columnspan $span -padx $padx -pady $pady -sticky $sticky
	    }

	    entry {
		set width 15
		
		if {$numargs < 2} {
		    error "wrong number of args for type $type:  should be \"$type variable \[width\] \[span\]\""
		}

		set var [lindex $element 1]
		if {$numargs > 2} {
		    set width [lindex $element 2]
		}
		if {$numargs > 3} {
		    set span [lindex $element 3]
		}

		set name ${win}.item${row}_$column
		entry $name -width $width -textvariable $var
		grid $name -row $row -column $column -columnspan $span -padx $padx -pady $pady -sticky $sticky
	    }

	    scale {
		set length 175
		set tickinterval 25
		
		if {$numargs < 3} {
		    error "wrong number of args for type $type:  should be \"$type variable orient \[length\]\""
		}

		set var [lindex $element 1]
		set orient [lindex $element 2]
		if {$numargs > 3} {
		    set length [lindex $element 3]
		}

		if {$numargs > 4} {
		    set span [lindex $element 4]
		}

		set name ${win}.item${row}_$column
		scale $name -variable $var -orient $orient -length $length -showvalue 0
		grid $name -row $row -column $column -columnspan $span -padx $padx -pady $pady -sticky $sticky
	    }
	    
	    radiobutton {
		if {$numargs < 4} {
		    error "wrong number of args for type $type:  should be \"$type text variable value \[command\] \[span\]\""
		}

		set text [lindex $element 1]
		set var [lindex $element 2]
		set value [lindex $element 3]
		if {$numargs > 4} {
		    set cmd [lindex $element 4]
		    if {$cmd != "NOP"} {
			set usecmd 1
		    }
		}
		if {$numargs > 5} {
		    set span [lindex $element 5]
		}

		set name ${win}.item${row}_$column
		if {$usecmd} {
		    radiobutton $name -variable $var -text $text -value $value -command $cmd
		} else {
		    radiobutton $name -variable $var -text $text -value $value
		}
		grid $name -row $row -column $column -columnspan $span -padx $padx -pady $pady -sticky $sticky
	    }

	    checkbutton {
		if {$numargs < 5} {
		    error "wrong number of args for type $type:  should be \"$type text variable onval offval \[command\] \[span\]\""
		}

		set text [lindex $element 1]
		set var [lindex $element 2]
		set onvalue [lindex $element 3]
		set offvalue [lindex $element 4]
		if {$numargs > 5} {
		    set cmd [lindex $element 5]
		    if {$cmd != "NOP"} {
			set usecmd 1
		    }
		}
		if {$numargs > 6} {
		    set span [lindex $element 6]
		}

		set name ${win}.item${row}_$column
		if {$usecmd} {
		    checkbutton $name -variable $var -text $text -onvalue $onvalue -offvalue $offvalue -command $cmd
		} else {
		    checkbutton $name -variable $var -text $text -onvalue $onvalue -offvalue $offvalue
		}
		grid $name -row $row -column $column -columnspan $span -padx $padx -pady $pady -sticky $sticky
	    }

	    chooser {
		if {$numargs < 3} {
		    error "wrong number of args for type $type:  should be \"$type variable valuelist \[span\]\""
		}

		set var [lindex $element 1]
		set valuelist [lindex $element 2]
		if {$numargs > 3} {
		    set span [lindex $element 3]
		}

		set name ${win}.item${row}_$column
		eval tk_optionMenu $name $var $valuelist
		grid $name -row $row -column $column -columnspan $span -padx $padx -pady $pady -sticky $sticky
	    }

	    interp_select {
		set span1 1
		set span2 1
		set span3 1
		
		if {$numargs < 3} {
		    error "wrong number of args for type $type:  should be \"$type typevar alphavar \[span1\] \[span2\] \[span3\]\""
		}

		set typevar [lindex $element 1]
		set alphavar [lindex $element 2]
		if {$numargs > 3} {
		    set span1 [lindex $element 3]
		}
		if {$numargs > 4} {
		    set span2 [lindex $element 4]
		}
		if {$numargs > 5} {
		    set span3 [lindex $element 5]
		}
		
		set name ${win}.item${row}_$column

		label ${name}_lbl -text "Interpolation: "
		label ${name}_alphalbl -text "  Alpha:"
		entry ${name}_alphaent -textvariable $alphavar -width 5
		radiobutton ${name}_r1 -text "Nearest Neighbor" -variable $typevar -value 1\
			-command [subst {
		    ${name}_alphaent configure -state disabled -fg [${name}_alphaent cget -bg]
		                         }]
		radiobutton ${name}_r2 -text "Bi-Linear" -variable $typevar -value 2\
			-command [subst {
		    ${name}_alphaent configure -state disabled -fg [${name}_alphaent cget -bg]
		                         }]
		radiobutton ${name}_r3 -text "Parametric Cubic" -variable $typevar -value 3\
			-command [subst {
		    ${name}_alphaent configure -state normal -fg [${name}_alphaent cget -fg]
		                         }]

		${name}_r1 invoke

		grid ${name}_lbl -row $row -column $column -columnspan $span1 -padx $padx -pady $pady -sticky $sticky
		grid ${name}_r1 -row $row -column [expr $column+$span1] -columnspan $span2 -padx $padx -pady $pady -sticky $sticky
		incr row
		grid ${name}_r2 -row $row -column [expr $column+$span1] -columnspan $span2 -padx $padx -pady $pady -sticky $sticky
		incr row
		grid ${name}_r3 -row $row -column [expr $column+$span1] -columnspan $span2 -padx $padx -pady $pady -sticky $sticky
		grid ${name}_alphalbl -row $row -column [expr $column+$span1+$span2] -columnspan $span3 -padx $padx -pady $pady -sticky $sticky
		grid ${name}_alphaent -row $row -column [expr $column+$span1+$span2+$span3] -columnspan 1 -padx $padx -pady $pady -sticky $sticky
	    }

	    skip {
		set span 1
	    }

	    default {
		error "Unknown element type ${type}.  Should be: label, imgchooser, entry, radiobutton, checkbutton, chooser, or skip."
	    }
	}
	incr column $span
    }

    return [expr $row + 1]
}

proc dialog_input {win} {
     return "$win.input"
}
proc dialog_output {win} {
     return "$win.output"
}



proc seg_dialog_create {class {win "auto"}} {
    if {$win == "auto"} {
        set count 0
        set win ".dialog[incr count]"
        while {[winfo exists $win]} {
            set win ".dialog[incr count]"
        }
    }

    # In case there is already a window by this name,
    # eliminate it!
    if {[winfo exists $win]} {
	destroy $win
    }
    
    toplevel $win -class $class

    frame $win.title
    frame $win.input
   #frame $win.output
    frame $win.xsep -width 2 -borderwidth 1 -relief sunken
    frame $win.ysep -height 2 -borderwidth 1 -relief sunken
    frame $win.controls

    grid $win.title -row 0 -column 0 -columnspan 3 -padx 4 -pady 4 -sticky news
    grid $win.ysep -row 1 -column 0 -columnspan 3 -padx 4 -sticky ew
    grid $win.input -row 2 -column 0 -padx 4 -pady 4 -sticky news
   #grid $win.output -row 3 -column 0 -padx 4 -pady 4 -sticky news
    grid $win.xsep -row 2 -column 1 -rowspan 2 -pady 4 -sticky ns
    grid $win.controls -row 2 -column 2 -rowspan 2 -padx 4 -pady 4 -sticky news

    grid columnconfigure $win 0 -weight 1
    grid rowconfigure $win 2 -weight 1

    wm title $win $class
    wm group $win .
    wm resizable $win 0 0

    return $win
}


proc dialog_safeguard {win} {
    if {[lsearch [bindtags $win] modalDialog] < 0} {
       bindtags $win [linsert [bindtags $win] 0 modalDialog]
      }
}
