#if HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */
#include <stdlib.h>
#include <sadie.h>
#include "chain.h"


void CHAIN2DISK (
CHAIN *chainmap,              /* Pointer to chain structure */
char *filename                /* Filename for saving the chain code */
) {
    unsigned char termcode, termvalid;
    LIST_NODE *current_lnode;
    CHAIN_NODE *current_cnode;
    FILE *fp;

    fp = fopen(filename, "w");
    if (fp == NULL) {
        MESSAGE('E'," Unable to open file for writing chain code.");
        goto the_end;
    }

    termcode = TERM_CODE;
    termvalid = TERM_VALID;

    /* Write header to disk */
    fwrite((char *)&(chainmap->nlin), CHAIN_HEADER_SIZE, 1, fp);
    current_lnode = chainmap->list;
    while (current_lnode != NULL) {
	fwrite((char *)&(current_lnode->startj), 2*sizeof(unsigned int), 1, fp);
	fwrite((char *)&(current_lnode->ring_type), sizeof(unsigned char), 1, fp);
	fwrite((char *)&(current_lnode->ring_id), sizeof(int), 1, fp);
	current_cnode = current_lnode->chain;
	while (current_cnode != NULL) {
	    /* Write chain code and valid byte */
	    fwrite((char *)&(current_cnode->code), 2*sizeof(unsigned char), 1, fp);
	    current_cnode = (CHAIN_NODE *)current_cnode->next;
	}
	/* Write terminating code(9) and valid byte for chain */
	fwrite((unsigned char *)&termcode, sizeof(unsigned char), 1, fp);
	fwrite((unsigned char *)&termvalid, sizeof(unsigned char), 1, fp);

	current_lnode = current_lnode->next;
    }
    fclose(fp);
    
    the_end:
}

