#ifndef MOTION_H
#define MOTION_H 1
#include "project_utilities.h"

BEGIN_C_DECLARATIONS

typedef enum
  {
    STAGEPROP_NONE  = 0,
    STAGEPROP_HEAVY = 1
  } motion_stageflags;

typedef long int coord_t;
typedef long int wait_t;
typedef unsigned char portdata_t;
typedef int axismapentry_t;

typedef struct Devicestate * devicestatep_t;

typedef struct Axismapping * axismappingp_t;

typedef struct Stagelocation * stagelocationp_t;

typedef struct Stagecontrol * stagecontrolp_t;

typedef struct Translation * translationp_t;

axismappingp_t newaxismapping (const unsigned int axes);
void disposeaxismapping (axismappingp_t themap);
void setaxismapping (axismappingp_t themap,
                     const unsigned int logical, const axismapentry_t physical);
stagelocationp_t newstagelocation (const unsigned int axes);
void disposestagelocation (stagelocationp_t theloc);
void setstagelocation (stagelocationp_t theloc, const unsigned int axisn, const coord_t newval);
coord_t getstagelocation (const stagelocationp_t theloc, const unsigned int axisn);
stagecontrolp_t newstage (const axismappingp_t themap);
void disposestage (stagecontrolp_t stage);
int openstage (stagecontrolp_t stage, const char *path, const int flags);
int closestage (stagecontrolp_t stage);
int movestage (stagecontrolp_t stage, const stagelocationp_t motn);
int findstage (stagecontrolp_t stage, stagelocationp_t posn);
int stageactive (stagecontrolp_t stage);

END_C_DECLARATIONS

#endif /* !MOTION_H */
