/* Enable the SADIE libraries to be linked to C++ code */
#ifdef __cplusplus
extern "C" {
#endif 

#ifndef TREES_H
#define TREES_H

#include <sadie.h>
#include "proto.h"
#include "mosaic.h"
#include "sadie_byte.h"

/*----------------------------------------------------------------------------*/
/* Maximum length of brightness profile for a single ring... */
#define MAXPROFILE 8388608

extern void CREATETREESMOSAIC (char **, int, char *, int, int, int, int, int,
			       int *, int *, PIXEL *, PIXEL*, PIXEL, PIXEL, PIXEL,
			       IMAGE_BYTE **, MOSAIC_INDEX **);
extern void TRIM (IMAGE *, uint32_t, IMAGE **);

extern void **MATRIX(int, int, int, int, int);
extern void SPLINE (int, float *, float *, float, float);
extern void DIVSER (int, float *, float *, float *);

extern void COMPUTEVSTART (MOSAIC_INDEX *, int, int, int, int);
extern void COMPUTEVEND (MOSAIC_INDEX *, int, int, int, int);
extern void COMPUTE_LOCAL_INDEX (MOSAIC_INDEX *, int, int, int, int, int, LOCAL_INDEX **);

extern void TREES_SCONVL (IMAGE *, LOCAL_INDEX *, PIXEL *, uint32_t, uint32_t, IMAGE **);
extern void TREES_GRADIENT (IMAGE *, LOCAL_INDEX *, PIXEL *, PIXEL *, uint32_t, IMAGE **, IMAGE **);
extern void TREES_TREERINGMAG (IMAGE *, LOCAL_INDEX *, double, int, IMAGE **, IMAGE **);

#endif

#ifdef __cplusplus
}
#endif
