#if HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */
#include <sadie.h>
#include "proto.h"

/*----------------------------------------------------------------------------*/
/*-General Information--------------------------------------------------------*/
/*                                                                            */
/*   This function copies an image.                                           */
/*                                                                            */
/*----------------------------------------------------------------------------*/
/*-Interface Information------------------------------------------------------*/
void IMGCOPY (
IMAGE  *in,      /*  I   Pointer to the input image.                           */
IMAGE  **out     /*  O   Address of a pointer to the output image             */
/*----------------------------------------------------------------------------*/
) { register uint32_t i, j, k;
    char msg[SLEN];

    /* if (TIMES) TIMING(T_IMGCOPY); */
    if (NAMES) {
        MESSAGE('I',"");
        MESSAGE('I',"IMGCOPY");
        MESSAGE('I',"");
        sprintf(msg," Input image:                       %s",in->text);
        MESSAGE('I',msg);
        MESSAGE('I'," ...............");
    }

    /* check input */
    if (!CHECKIMG(in)) {
        MESSAGE('E'," Can't identify image.");
        goto the_end;
    }


    /* create output image of appropriate size */
    if (!CHECKIMG(*out)) GETMEM(in->nbnd,in->nlin,in->npix,out);
    if (!*out) goto the_end;

    /* build copy image */
    for (i=0; i<in->nbnd; i++) {
        for (j=0; j<in->nlin; j++) {
            for (k=0; k<in->npix; k++) {
                (*out)->data[i][j][k] = in->data[i][j][k];
            }
        }
    }

    	
    the_end:
    /* if (TIMES) TIMING(T_EXIT); */
}
