#if HAVE_CONFIG_H
#include <config.h>
#endif /* HAVE_CONFIG_H */
#include <tcl.h>
#include <tk.h>
#include <stdio.h>
#include <string.h>

extern Tcl_Interp* MainTclInterp;

int ProgMeter_Create(char *title)
{
    char tclstr[200];
    Tcl_Obj *tclcommand=NULL;
    int gaugenum;
    Tcl_Obj *objectresult=NULL;


    sprintf(tclstr, "gauge_gui_add \"%s\"",title);
    tclcommand = Tcl_NewStringObj(tclstr, -1);
/*    //if(Tcl_EvalObj(MainTclInterp, tclcommand,TCL_GLOBAL_ONLY) != TCL_OK ) { */
    if(Tcl_EvalObj(MainTclInterp, tclcommand) != TCL_OK ) {
        Tcl_BackgroundError(MainTclInterp);
        return 0;
    }
    
    objectresult = Tcl_GetObjResult(MainTclInterp);
    if (Tcl_GetIntFromObj(MainTclInterp, objectresult, &gaugenum) != TCL_OK) {
        Tcl_BackgroundError(MainTclInterp);
        return 0;    
    } else {
        return gaugenum;
    }
}



int ProgMeter_Update(int gaugenum, double value)
{
    char tclstr[200];
    Tcl_Obj *tclcommand=NULL;
    Tcl_Obj *objectresult=NULL;
    int cancelval;
  
    sprintf(tclstr, "gauge_gui_update %d %f",gaugenum,value);
    if( Tcl_Eval(MainTclInterp, tclstr) != TCL_OK ) {
        Tcl_BackgroundError(MainTclInterp);
        return -1;
    }

    objectresult = Tcl_GetObjResult(MainTclInterp);
    if (Tcl_GetIntFromObj(MainTclInterp, objectresult, &cancelval) != TCL_OK) {
        Tcl_BackgroundError(MainTclInterp);
        return -1;    
    } else {
        return cancelval;
    }

}


int ProgMeter_Destroy(int gaugenum)
{
    char tclstr[200];
  
    sprintf(tclstr, "gauge_gui_delete %d",gaugenum);
    if( Tcl_Eval(MainTclInterp, tclstr) != TCL_OK ) {
        Tcl_BackgroundError(MainTclInterp);
        return 0;
    } else {
        return 1;
    }
}
